extern "C" {

void *memchr(void *buf, int c, size_t count) {
    char *p = (char *)buf;
    for (size_t i = 0; i < count; i++, p++) {
        if (*p == c) return p;
    }
    return 0;
}

int memcmp(const void* buf1, const void* buf2, size_t count) {
    char *p1 = (char *)buf1;
    char *p2 = (char *)buf2;
    for (size_t i = 0; i < count; i++) {
        if (*p1 > *p2) return 1;
        if (*p1 < *p2) return -1;
        p1++;
        p2++;
    }
    return 0;
}

char *memset (char *dst, char value, size_t count) {
	char *start = dst;
	while (count--)
		*dst++ = value;
	return start;
}

void *memcpy(void * dst, void * src, size_t count) {
	char *p1 = (char *)dst;
	char *p2 = (char *)src;
	void * ret = dst;
	while (count--)
		*p1++ = *p2++;
	return ret;
}

}